/* ----------------------------------------------------------------------
   A. Veneziani - Programma che effettua la somma di due frazioni
                  in modo banale e successivamente una riduzione
                  della frazione risultante

                  Scritto in C++ Builder 6
   ---------------------------------------------------------------------- */          

#include <iostream>

using namespace std;

struct frazione {
  int numeratore;
  int denominatore;
};

// individua se il numero intero n e' divisibile per l'intero d
bool e_divisibile(int n, int d)
{
    if ((n % d) == 0)
       return(true);
    else
       return(false);
};

// controlla la primalita' del numero n
bool e_primo(int n)
{
    int scan;
    bool primo;

    primo = true;
    for (scan = 2; scan < n; scan++)
        if ((n % scan) == 0)
        {
            primo = false;
            break;
        }

    return(primo);
};

// trova un primo successivo dato il precedente
int primo_succ(int np)
{
    int scan;

    scan = np + 1;
    while (! e_primo(scan))  scan++;

    return(scan);
};

void riduci_fraz(frazione* fr)
{
     int divis, n_minimo;

     // ciclo di riduzione del numeratore e denominatore
     // finche' il divisore raggiunge il minimo  tra numeratore e denominatore
     divis = 2;
     while (divis <= min(abs((*fr).numeratore), abs((*fr).denominatore)))
     {
          if ((e_divisibile((*fr).numeratore,divis)) &&
                (e_divisibile((*fr).denominatore,divis)))
         {
              (*fr).numeratore = (*fr).numeratore / divis;
              (*fr).denominatore = (*fr).denominatore / divis;
         }
         else
              divis = primo_succ(divis);
     }
};

int main()
{
     // dichiarazione delle frazioni
     // relative ai due addendi e al risultato
     frazione fr1, fr2, fr_somma;

     // lettura delle frazioni
     cout << "Programma che legge la somma di due frazioni." << endl;
     cout << "Leggi la prima frazione (num den):  ";
     cin >> fr1.numeratore >> fr1.denominatore;
     cout << "Leggi la seconda frazione (num den):  ";
     cin >> fr2.numeratore >> fr2.denominatore;

     // calcolo della somma mediante la formula "banale" (senza riduzione)s
     fr_somma.numeratore = fr1.numeratore * fr2.denominatore +
                           fr2.numeratore * fr1.denominatore;

     fr_somma.denominatore = fr1.denominatore * fr2.denominatore;

     // riduzione del risultato
     riduci_fraz(&fr_somma);

     // output della frazione risultante 
     cout << "La frazione risultato della somma e':  " <<
             fr_somma.numeratore << "/" << fr_somma.denominatore << endl << endl;

     system("PAUSE");      // attende un tasto per proseguire

     return(0);
}
